
import Taro from '@tarojs/taro'
import { useMemo } from 'react'
import useRouter from '@/utils/hooks/useRouter'
import LoginModel from "@/components/LoginModel";
import Spin from "@/components/Spin";
import { useModel } from '@/store'
import useLogin from '@/utils/hooks/useLogin'


export default (Child) => (props) => {
  const { person } = useModel('person')
  const { location, setLocation } = useModel('location')
  const router = useRouter()

  if (!location) {
    setLocation(Taro.getStorageSync('location'))
  }
  //确保不是首页并且没有手机号时
  const { loginVisible } = useLogin()

  // 确保执行过 login 方法，拿到了 person
  const isLoged = useMemo(() => !!person?.personId, [person?.personId])

  return (
    <>
      {!isLoged && <Spin />}
      {
        isLoged && !loginVisible && <Child {...props} router={router} location={location} />
      }
      {
        isLoged && loginVisible && <LoginModel />
      }
    </>
  )
}
